local lexers = {
    {
        extensions = { ".c", ".h" },
        lang = "c",
        lexername = "cpp",
        conf = "style/c.lua"
    },

    {
        extensions = { ".cc", ".cpp", ".cxx", ".hh", ".hpp", ".hxx", ".ipp", ".mm", ".sma" },
        lang = "c++",
        lexername = "cpp",
        conf = "style/cpp.lua"
    },
    {
        extensions = { ".java", ".jad", ".pde" },
        lang = "java",
        lexername = "cpp",
        conf = "style/java.lua"
    },
    {
        extensions = { ".idl", ".odl" },
        lang = "idl",
        lexername = "cpp",
        conf = "style/idl.lua"
    },
    {
        extensions = { ".cs" },
        lang = "c#",
        lexername = "cpp",
        conf = "style/cs.lua"
    },
    {
        extensions = { ".js", ".es", ".ts" },
        lang = "javascript",
        lexername = "cpp",
        conf = "style/javascript.lua"
    },

    {
        extensions = { ".as", ".asc", ".jsfl" },
        lang = "flash",
        lexername = "cpp",
        conf = "style/flash.lua"
    },
    {
        extensions = { ".ch", ".chf", ".chs" },
        lang = "ch",
        lexername = "cpp",
        conf = "style/flash.lua"
    },
    {
        extensions = { ".vala" },
        lang = "vala",
        lexername = "cpp",
        conf = "style/vala.lua"
    },
    {
        extensions = { ".go" },
        lang = "go",
        lexername = "cpp",
        conf = "style/go.lua"
    },
    {
        extensions = { ".pike" },
        lang = "pike",
        lexername = "cpp",
        conf = "style/pike.lua"
    },
    {
        extensions = { ".swift" },
        lang = "swift",
        lexername = "cpp",
        conf = "style/swift.lua"
    },

    {
        extensions = { ".bat", ".cmd", ".nt" },
        lang = "batch",
        lexername = "batch",
        conf = "style/bat.lua"
    },

    {
        extensions = { ".properties", ".session", ".ini", ".inf", ".url", ".cfg", ".cnf", ".aut" },
        lang = "props",
        lexername = "props",
        conf = "style/props.lua"
    },

    {
        extensions = { ".diff", ".patch" },
        lang = "diff",
        lexername = "diff",
        conf = "style/diff.lua"
    },


    {
        extensions = { ".vb", ".bas", ".frm", ".cls", ".ctl", ".pag", ".dsr", ".dob" },
        lang = "vb",
        lexername = "vb",
        conf = "style/vb.lua"
    },

    {
        extensions = { ".vbs", ".dsm" },
        lang = "wscript",
        lexername = "vbscript",
        conf = "style/vbscript.lua"
    },

    {
        extensions = { ".sh", ".bash", ".bsh", "configure", ".ksh" },
        lang = "shell",
        lexername = "bash",
        conf = "style/bash.lua"
    },
    {
        extensions = { ".conf", ".htaccess" },
        lang = "conf",
        lexername = "conf",
        conf = "style/conf.lua"
    },
    {
        extensions = { "CMakeLists.txt", ".cmake", ".cmake.in", ".ctest", ".ctest.in" },
        lang = "cmake",
        lexername = "cmake",
        conf = "style/cmake.lua"
    },
    {
        extensions = { "makefile", "Makefile", ".mak", ".mk" },
        lang = "makefile",
        lexername = "makefile",
        conf = "style/make.lua"
    },
    {
        extensions = { ".json", ".eslintrc", ".jshintrc", ".jsonld" },
        lang = "json",
        lexername = "json",
        conf = "style/json.lua"
    },
    {
        extensions = { ".py", ".pyw", ".pyx", ".pxd", ".pxi" },
        lang = "python",
        lexername = "python",
        conf = "style/python.lua"
    },
    {
        extensions = { ".yaml", ".yml" },
        lang = "yaml",
        lexername = "yaml",
        conf = "style/yaml.lua"
    },
    {
        extensions = { ".pl", ".pm", ".pod" },
        lang = "perl",
        lexername = "perl",
        conf = "style/perl.lua"
    },
    {
        extensions = { ".awk" },
        lang = "awk",
        lexername = "perl",
        conf = "style/awk.lua"
    },
    {
        extensions = { ".lsp", ".lisp" },
        lang = "lisp",
        lexername = "lisp",
        conf = "style/lisp.lua"
    },
    {
        extensions = { ".scm", ".smd", ".ss" },
        lang = "scheme",
        lexername = "lisp",
        conf = "style/scheme.lua"
    },
    {
        extensions = { ".lua" },
        lang = "lua",
        lexername = "lua",
        conf = "style/lua.lua"
    },
    {
        extensions = { ".rb", ".rbw", ".rake", ".rjs", "Rakefile" },
        lang = "ruby",
        lexername = "ruby",
        conf = "style/ruby.lua"
    },
    {
        extensions = { ".rs" },
        lang = "rust",
        lexername = "rust",
        conf = "style/rust.lua"
    },
    {
        extensions = { ".erl", ".hrl" },
        lang = "erlang",
        lexername = "erlang",
        conf = "style/erlang.lua"
    },
    {
        extensions = { ".forth", ".fth" },
        lang = "forth",
        lexername = "forth",
        conf = "style/forth.lua"
    },

    {
        extensions = { ".hs" },
        lang = "haskell",
        lexername = "haskell",
        conf = "style/haskell.lua"
    },

    {
        extensions = { ".tex", ".sty", ".aux", ".toc", ".idx" },
        lang = "latex",
        lexername = "tex",
        conf = "style/latex.lua"
    },

    {
        extensions = { ".tex", ".sty" },
        lang = "tex",
        lexername = "tex",
        conf = "style/tex.lua"
    },

    {
        extensions = { ".sql" },
        lang = "sql",
        lexername = "sql",
        conf = "style/sql.lua"
    },

    {
        extensions = { ".spec", ".body", ".sps", ".spb", ".sf", ".sp" },
        lang = "plsql",
        lexername = "sql",
        conf = "style/plsql.lua"
    },

    {
        extensions = { ".css" },
        lang = "css",
        lexername = "css",
        conf = "style/css.lua"
    },

    {
        extensions = { ".smali" },
        lang = "smali",
        lexername = "smali",
        conf = "style/smali.lua"
    },

    {
        extensions = { ".hocon" },
        lang = "hocon",
        lexername = "hocon",
        conf = "style/hocon.lua"
    },

    {
        extensions = { ".asm" },
        lang = "asm",
        lexername = "asm",
        conf = "style/asm.lua"
    },

    {
        extensions = { ".s" },
        lang = "as",
        lexername = "as",
        conf = "style/as.lua"
    },

    {
        extensions = { ".m.octave" },
        lang = "octave",
        lexername = "octave",
        conf = "style/octave.lua"
    },

    {
        extensions = { ".m", ".m.octave" },
        lang = "matlab",
        lexername = "matlab",
        conf = "style/matlab.lua"
    },

    {
        extensions = { ".mot", ".srec" },
        lang = "srec",
        lexername = "srec",
        conf = "style/hex.lua"
    },

    {
        extensions = { ".ihex" },
        lang = "ihex",
        lexername = "ihex",
        conf = "style/hex.lua"
    },

    {
        extensions = { ".tek" },
        lang = "tehex",
        lexername = "tehex",
        conf = "style/hex.lua"
    },
    {
        extensions = {
            ".html", ".htm", ".asp", ".shtml", ".htd", ".jsp", ".xhtml",
            ".htt", ".cfm", ".tpl", ".dtd", ".hta", ".php3", ".phtml", ".php"
        },
        lang = "html",
        lexername = "hypertext",
        conf = "style/html.lua"
    },
    {
        extensions = { ".docbook" },
        lang = "docbook",
        lexername = "hypertext",
        conf = "style/docbook.lua"
    },
    {
        extensions = { ".xml", ".xsl", ".svg", ".xul", ".xsd", ".dtd", ".xslt", ".axl", ".xrc", ".rdf" },
        lang = "xml",
        lexername = "xml",
        conf = "style/xml.lua"
    },
    {
        extensions = { ".vxml" },
        lang = "vxml",
        lexername = "hypertext",
        conf = "style/vxml.lua"
    },
    {
        extensions = { ".markdown", ".md", ".mdown", ".mkd", ".mkdn" },
        lang = "markdown",
        lexername = "markdown",
        conf = "style/markdown.lua"
    },

    {
        extensions = { ".dpr", ".pas", ".dfm", ".inc", ".pp" },
        lang = "pascal",
        lexername = "pascal",
        conf = "style/pascal.lua"
    },

    {
        extensions = { ".vhd", ".vhdl" },
        lang = "vhdl",
        lexername = "vhdl",
        conf = "style/vhdl.lua"
    },

    {
        extensions = { ".m" },
        lang = "objective-c",
        lexername = "cpp",
        conf = "style/objective-c.lua"
    },

    {
        extensions = { ".f90", ".f95", ".f2k", ".f", ".for" },
        lang = "fortran",
        lexername = "fortran",
        conf = "style/fortran.lua"
    },

    {
        extensions = { ".toml" },
        lang = "toml",
        lexername = "TOML",
        conf = "style/toml.lua"
    },

    {
        extensions = { ".csv" },
        lang = "csv",
        lexername = "CSV",
        conf = "style/csv.lua"
    },

    {
        extensions = { ".mib" },
        lang = "asn1",
        lexername = "asn1",
        conf = "style/asn1.lua"
    },

    --
    --        / / file.patterns.php = ".php3", ".phtml", ".php", ""
    --
    --file.patterns.mako = ".mak", ".mako"
    --
    --/ / lexer.php = {
    --    / / lexername = hypertext
    --        / / conf = html.conf
    --        / / }
    --lexer.mako = {
    --    lexername = hypertext
    --conf = html.conf
    --}
    --

    --
    --file.patterns.d = ".d"
    --lexer.d.lexername = d
    --lexer.d.conf = d.conf
    --

    {
        extensions = { ".txt", ".log", ".lst", ".diz", ".nfo" },
        lang = "text",
        lexername = "text",
        conf = "style/text.lua"
    }
}














--load external lexers if it exists
local extLexersFile = loadfile("extlexers.lua");
if extLexersFile ~= nil then
    local extLexers = extLexersFile()
    for i, v in ipairs(extLexers) do
        lexers[#lexers + 1] = v
    end
end

return lexers

