--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 2021/7/1
-- Time: 下午10:15
-- To change this template use File | Settings | File Templates.
--
local ASN1 = luajava.bindClass("jscintilla.lexers.asn1")
local keywords = {}

--Keywords
keywords[1] = [[
ACCESS AGENT AUGMENTS
BEGIN BITS
CAPABILITIES CHOICE COMPLIANCE CONTACT CONVENTION
DEFINITIONS DEFVAL DESCRIPTION DISPLAY
END ENTERPRISE EXPORTS
FALSE FROM
GROUP GROUPS
HINT
IDENTITY IMPLIED IMPORTS INCLUDES INDEX INFO
LAST
MANDATORY MAX MIN MODULE
NOTATION NOTIFICATION NULL
OBJECTS OBJECT-TYPE OF ORGANIZATION
PRODUCT
RELEASE REFERENCE REQUIRES REVISION
SEQUENCE SIZE STATUS SUPPORTS SYNTAX
TEXTUAL TRAP TYPE TRAP-TYPE
UPDATED
VALUE VARIABLES VARIATION
WRITE
]]

--Attributes
keywords[2] = [[
accessible
create current
deprecated
for
mandatory
not notify not - accessible
obsolete only optional
read read - only read - write
write
]]

--Descriptors
keywords[3] = [[
ABSENT ANY APPLICATION
BIT BOOLEAN BY
COMPONENT COMPONENTS
DEFAULT DEFINED
ENUMERATED EXPLICIT EXTERNAL
IMPLICIT INIFINITY
MAX MIN MINUS
OPTIONAL
PRESENT PRIVATE
REAL
SET
TAGS TRUE
]]

--Types
keywords[4] = [[
Counter Counter32 Counter64
DisplayString
Gauge Gauge32
IDENTIFIER INTEGER Integer32 IpAddress
NetworkAddress NsapAddress
OBJECT OCTET Opaque
PhysAddress
STRING
TimeTicks
UInteger32 UNITS Unsigned32
]]



local style = {}
--ASN .1 styles
--Default
--style[ASN1.COMMENT]=
--Comment
style[ASN1.COMMENT] = createStyle(fonts.comment, colors.codeCommentLine, {})
--Identifiers
style[ASN1.IDENTIFIER] = {
    bold = true
}
--Double quoted string
style[ASN1.STRING] = colors.string
--Numeric OID definition
style[ASN1.OID] = {
    fore = 0x007F7F,
    bold = true
}
--Non OID numbers
style[ASN1.SCALAR] = colors.number
--Keywords
style[ASN1.KEYWORD] = colors.keyword
--Attributes
style[ASN1.ATTRIBUTE] = {
    fore = 0xF07800
}
--Descriptors
style[ASN1.DESCRIPTOR] = {
    fore = 0x00007F
}
--Types
style[ASN1.TYPE] = {
    fore = 0x00007F
}
--Operators
style[ASN1.TYPE] = {
    fore = 0x222222
}


local properties = {}

return function() return keywords, style, properties end


