--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-8
-- Time: 19:36
-- To change this template use File | Settings | File Templates.
--

local PERL = luajava.bindClass("jscintilla.lexers.pl")
local keywords = {}

keywords[1] = [[
BEGIN END
if else while do for in break continue delete exit function return
print printf sprintf
system close getline next nextfile fflush
atan2 cos exp int log rand sin sqrt srand
asort asorti gensub sub gsub index length match split
strtonum substr tolower toupper
mktime strftime systime
and compl lshift or rshift xor
bindtextdomain dcgettext dcngettext
ARGC ARGIND ARGV BINMODE CONVFMT ENVIRON ERRNO FIELDWIDTHS
FILENAME FNR FS IGNORECASE LINT NF NR OFMT OFS ORS PROCINFO
RS RT RSTART RLENGTH SUBSEP TEXTDOMAIN
]]


local style = {}

--style[PERL.DEFAULT] =
style[PERL.ERROR] = colors.error
style[PERL.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
--POD: = at beginning of line
style[PERL.POD] = {
    fore = 0x004000,
    back = 0xE0FFE0,
    eolfilled = true
}
style[PERL.NUMBER] = colors.number
style[PERL.WORD] = colors.keyword
--Double quoted string
style[PERL.STRING] = colors.string
--Single quoted string
style[PERL.CHARACTER] = colors.string
--Symbols / Punctuation. Currently not used by LexPerl.
style[PERL.PUNCTUATION] = colors.notused
--Preprocessor. Currently not used by LexPerl.
style[PERL.PREPROCESSOR] = colors.preproc
--Operators
style[PERL.OPERATOR] = colors.operator
--Identifiers (functions, etc.)
--style[PERL.IDENTIFIER] =
--Scalars: $var
style[PERL.SCALAR] = {
    fore = 0x000000,
    back = 0xFFE0E0,
}
--Array: @var
style[PERL.ARRAY] = {
    fore = 0x000000,
    back = 0xFFFFE0,
}
--Hash: %var
style[PERL.HASH] = {
    fore = 0x000000,
    back = 0xFFE0FF,
}
--Symbol table: *var
style[PERL.SYMBOLTABLE] = {
    fore = 0x000000,
    back = 0xE0E0E0,
}
--SCE_PL_VARIABLE_INDEXER allocated but unused
style[PERL.VARIABLE_INDEXER] = {
    back = 0xFF0000,
}
--Regex: /re/ or m{re}
style[PERL.REGEX] = {
    fore = 0x000000,
    back = 0xA0FFA0,
}
--Substitution: s/re/ore/
style[PERL.REGSUBST] = {
    fore = 0x000000,
    back = 0xF0E080,
}
--Long Quote (qq, qr, qw, qx) -- obsolete: replaced by qq, qx, qr, qw
style[PERL.LONGQUOTE] = {
    fore = 0xFFFF00,
    back = 0x8080A0,
}
--Back Ticks
style[PERL.BACKTICKS] = createChild(colors.string, {
    back = 0x90FFFF,
})
--Data Section: __DATA__ or __END__ at beginning of line
style[PERL.DATASECTION] = {
    fore = 0x600000,
    back = 0xFFF0D8,
    eolfilled = true
}
--Here-doc (delimiter)
style[PERL.HERE_DELIM] = {
    fore = 0x000000,
    back = 0xDDD0DD,
}
--Here-doc (single quoted, q)
style[PERL.HERE_Q] = {
    fore = 0x7F007F,
    back = 0xDDD0DD,
}
--Here-doc (double quoted, qq)
style[PERL.HERE_QQ] = {
    fore = 0x7F007F,
    back = 0xDDD0DD,
    eolfilled = true,
    bold = true
}
--Here-doc (back ticks, qx)
style[PERL.HERE_QX] = {
    fore = 0x7F007F,
    back = 0xDDD0DD,
    eolfilled = true,
    italics = true
}
--Single quoted string, generic
style[PERL.STRING_Q] = {
    fore = 0x7F007F,
    bold = false
}
--qq = Double quoted string
style[PERL.STRING_QQ] = colors.string
--qx = Back ticks
style[PERL.STRING_QX] = createChild(colors.string, {
    back = 0x90FFFF,
})
--qr = Regex
style[PERL.STRING_QR] = style[PERL.REGEX]
--qw = Array
style[PERL.STRING_QW] = style[PERL.ARRAY]
--POD: verbatim paragraphs
style[PERL.POD_VERB] = {
    fore = 0x004000,
    back = 0xC0FFC0,
    eolfilled = true
}
--subroutine prototype
style[PERL.SUB_PROTOTYPE] = {
    italics = true
}
--format identifier
style[PERL.FORMAT_IDENT] = {
    fore = 0xC000C0,
    bold = true
}
--format body
style[PERL.FORMAT] = {
    fore = 0xC000C0,
    back = 0xFFF0FF,
    eolfilled = true
}
--Double quoted string (interpolated variable)
style[PERL.STRING_VAR] = createChild(colors.string, {
    bold = true
})

--translation: tr{}{} y{}{}
style[PERL.XLAT] = style[PERL.REGSUBST]
--Regex: /re/ or m{re} (interpolated variable)
style[PERL.REGEX_VAR] = createChild(style[PERL.REGEX], {
    bold = true
})
--Substitution: s/re/ore/ (interpolated variable)
style[PERL.REGSUBST_VAR] = createChild(style[PERL.REGSUBST], {
    bold = true
})
--Back Ticks (interpolated variable)
style[PERL.BACKTICKS_VAR] = createChild(style[PERL.BACKTICKS], {
    bold = true
})
--Here-doc (double quoted, qq) (interpolated variable)
style[PERL.HERE_QQ_VAR] = createChild(style[PERL.HERE_QQ], {
    bold = true
})
--Here-doc (back ticks, qx) (interpolated variable)
style[PERL.HERE_QX_VAR] = style[PERL.HERE_QQ_VAR]
--qq = Double quoted string (interpolated variable)
style[PERL.STRING_QQ_VAR] = style[PERL.STRING_VAR]
--qx = Back ticks (interpolated variable)
style[PERL.STRING_QX_VAR] = style[PERL.BACKTICKS_VAR]
--qr = Regex (interpolated variable)
style[PERL.STRING_QR_VAR] = style[PERL.REGEX_VAR]


local properties = {}

return function() return keywords, style, properties end

