--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-8
-- Time: 4:57
-- lexer config for bash,ksh...
--
local SH = luajava.bindClass("jscintilla.lexers.sh")

local keywords = {}

keywords[1] = [[
alias
ar asa awk banner basename bash bc bdiff break
bunzip2 bzip2 cal calendar case cat cc cd chmod cksum
clear cmp col comm compress continue cp cpio crypt
csplit ctags cut date dc dd declare deroff dev df diff diff3
dircmp dirname do done du echo ed egrep elif else env
esac eval ex exec exit expand export expr false fc
fgrep fi file find fmt fold for function functions
getconf getopt getopts grep gres hash head help
history iconv id if in integer jobs join kill local lc
let line ln logname look ls m4 mail mailx make
man mkdir more mt mv newgrp nl nm nohup ntps od
pack paste patch pathchk pax pcat perl pg pr print
printf ps pwd read readonly red return rev rm rmdir
sed select set sh shift size sleep sort spell
split start stop strings strip stty sum suspend
sync tail tar tee test then time times touch tr
trap true tsort tty type typeset ulimit umask unalias
uname uncompress unexpand uniq unpack unset until
uudecode uuencode vi vim vpax wait wc whence which
while who wpaste wstart xargs zcat

chgrp chown chroot dir dircolors
factor groups hostid install link md5sum mkfifo
mknod nice pinky printenv ptx readlink seq
sha1sum shred stat su tac unlink users vdir whoami yes
]]


local style = {}

--style[SH.DEFAULT ] =
--Error
style[SH.ERROR] = colors.error
--Comment
style[SH.COMMENTLINE] = createStyle(fonts.codeCommentLine, colors.codeCommentLine, {})
--Number
style[SH.NUMBER] = colors.number
--Keyword
style[SH.WORD] = createChild(colors.keyword, { bold = true })
--Double quoted string
style[SH.STRING] = colors.string
--Single quoted string
style[SH.CHARACTER] = colors.string
style[SH.OPERATOR] = colors.operator
--Identifiers (functions, etc.)
--style[SH.IDENTIFIER] =
--Scalars: $var
style[SH.SCALAR] = {
    fore = 0x000000,
    back = 0xFFE0E0
}
--Parameter expansion: ${var}
style[SH.PARAM] = colors.identifierVar
--Back Ticks
style[SH.BACKTICKS] = colors.identifierVar
--Here-doc (delimiter)
style[SH.HERE_DELIM] = {
    fore = 0x000000,
    back = 0xDDD0DD
}
--Here-doc (single quoted, q)
style[SH.HERE_Q] = {
    back = 0xDDD0DD,
    eolfilled = true,
    bold = false
}


wordCharacters = characters.alpha .. characters.numeric .. "_-$/.*"


editor.settings.indent.starts = { "do", "else", "then", "in", "{", ")" }
editor.settings.indent.ends = { "end", "fi", "}", "esac" }

local properties = {}

return function() return keywords, style, properties end

