--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-8
-- Time: 4:57
-- lexer config for bash,ksh...
--
local BAT = luajava.bindClass("jscintilla.lexers.bat")

local keywords = {}

keywords[1] = [[
assoc aux break call cd chcp chdir choice cls cmdextversion
color com1 com2 com3 com4 con copy ctty date defined
del dir do dpath echo else endlocal erase errorlevel exist
exit for ftype goto if in lpt1 lpt2 lpt3 lpt4 md mkdir move
not nul path pause popd prompt prn pushd rd rem ren
rename rmdir set setlocal shift start time title type ver
verify vol
]]


local style = {}

--style[BAT.DEFAULT ] =
--Comment
style[BAT.COMMENT] = createStyle(fonts.comment, colors.codeCommentLine, {})

--Keyword
style[BAT.WORD] = createChild(colors.keyword, { bold = true })
--Label (line beginning with ':')
style[BAT.LABEL] = createChild(colors.string, { eolfilled = true })
--Hide command character ('@')
style[BAT.HIDE] = colors.preproc
--External commands
style[BAT.COMMAND] = {
    fore = 0x007090,
    bold = true
}
--Variable: %%x (x is almost whatever, except space and %), %n (n in [0-9]), %EnvironmentVar%
style[BAT.IDENTIFIER] = {
    fore = 0x800080
}
--Operator: * ? < > |
style[BAT.OPERATOR] = colors.operator


local properties = {}

return function() return keywords, style, properties end

