--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-5
-- Time: 13:43
-- To change this template use File | Settings | File Templates.
--
local C = luajava.bindClass("jscintilla.lexers.c")
local keywords = {}

keywords[1] = [[
alignas alignof and and_eq asm auto bitand bitor bool break
case catch char char16_t char32_t class compl const constexpr const_cast continue
decltype default delete do double dynamic_cast else enum explicit export extern false final float for
friend goto if inline int long mutable namespace new noexcept not not_eq nullptr
operator or or_eq override private protected public
register reinterpret_cast return short signed sizeof static static_assert static_cast struct switch
template this thread_local throw true try typedef typeid typename union unsigned using
virtual void volatile wchar_t while xor xor_eq

@class @defs @protocol @required @optional @end
@interface @public @package @protected @private @property
@implementation @synthesize @dynamic
@throw @try @catch @finally
@synchronized @autoreleasepool
@selector @encode
@compatibility_alias
]]
keywords[2] = "file"

keywords[3] = [[
a addindex addtogroup anchor arg attention
author b brief bug c class code date def defgroup deprecated dontinclude
e em endcode endhtmlonly endif endlatexonly endlink endverbatim enum example exception
f$ f[ f] file fn hideinitializer htmlinclude htmlonly
if image include ingroup internal invariant interface latexonly li line link
mainpage name namespace nosubgrouping note overload
p page par param param[in] param[out]
post pre ref relates remarks return retval
sa section see showinitializer since skip skipline struct subsection
test throw throws todo typedef union until
var verbatim verbinclude version warning weakgroup $ @  & < > # { }
]]

local style = {}

--style[C.DEFAULT] =
--Comment: /* */.
style[C.COMMENT] = createStyle(fonts.codeCommentBox, colors.codeCommentBox, {})
--Line Comment: //.
style[C.COMMENTLINE] = createStyle(fonts.codeCommentLine, colors.codeCommentLine, {})
--Doc comment: block comments beginning with /** or /*
style[C.COMMENTDOC] = createStyle(fonts.codeCommentLine, colors.codeCommentDocText, {})
--Number
style[C.NUMBER] = colors.number
--Keyword
style[C.WORD] = createChild(colors.keyword, { bold = true })
--Double quoted string
style[C.STRING] = colors.string
--Single quoted string
style[C.CHARACTER] = colors.char
--Preprocessor
style[C.PREPROCESSOR] = colors.preproc
--Operators
style[C.OPERATOR] = colors.operator
--style[C.IDENTIFIER] =

--End of line where string is not closed
style[C.STRINGEOL] = createChild(colors.string, {
    back = 0xE0C0E0,
    eolfilled = true
})

--Doc Comment Line: line comments beginning with /// or //!.
style[C.COMMENTLINEDOC] = createStyle(fonts.codeCommentLine, colors.codeCommentDocText, {})

--keywords2 is for highlighting user defined keywords or function calls or similar
--Keywords2
style[C.WORD2] = {
    fore = 0xC0C0C0,
    bold = true
}

--Comment keyword
style[C.COMMENTDOCKEYWORD] = { fore = 0xC0C0C0 }
--Comment keyword error
style[C.COMMENTDOCKEYWORDERROR] = { fore = 0xC0C0C0 }

--Global class
style[C.GLOBALCLASS] = { fore = 0xDD9900 }
--Raw strings for C++0x
style[C.STRINGRAW] = {
    back = 0xFFF3FF,
    eolfilled = true
}

--Preprocessor stream comment
style[C.PREPROCESSORCOMMENT] = { fore = 0x659900 }
--Preprocessor stream doc comment
style[C.PREPROCESSORCOMMENTDOC] = colors.codeCommentDocText
--User defined literals
style[C.USERLITERAL] = { fore = 0xC06000 }
style[C.TASKMARKER] = { fore = 0xBE07FF }
style[C.ESCAPESEQUENCE] = colors.string


--# Inactive states are 64 greater than their active counterparts

--style[64+C.DEFAULT] =
--Comment: /* */.
style[64 + C.COMMENT] = createChild(style[C.COMMENT], {
    fore = 0x90B090,
})
--Line Comment: //.
style[64 + C.COMMENTLINE] = createChild(style[C.COMMENTLINE], {
    fore = 0x90B090
})
--Doc comment: block comments beginning with /** or /*

style[64 + C.COMMENTDOC] = createChild(style[C.COMMENTDOC], {
    fore = 0x90B090
})
--Number
style[64 + C.NUMBER] = style[C.NUMBER]
--Keyword
style[64 + C.WORD] = createChild(colors.keyword, {
    fore = 0x9090B0,
})
--Double quoted string
style[64 + C.STRING] = style[C.STRING]
--Single quoted string
style[64 + C.CHARACTER] = style[C.CHARACTER]
--Preprocessor
style[64 + C.PREPROCESSOR] = createChild(style[C.PREPROCESSOR], {
    fore = 0xB0B090,
})
--Operators
style[64 + C.OPERATOR] = createChild(style[C.OPERATOR], {
    fore = 0xB0B0B0,
})
style[64 + C.IDENTIFIER] = createChild(style[C.IDENTIFIER], {
    fore = 0xB0B0B0,
})

--End of line where string is not closed
style[64 + C.STRINGEOL] = style[C.STRINGEOL]

--Doc Comment Line: line comments beginning with /// or //!.
style[64 + C.COMMENTLINEDOC] = style[C.COMMENTLINEDOC]

--keywords2 is for highlighting user defined keywords or function calls or similar
--Keywords2
style[64 + C.WORD2] = style[C.WORD2]

--Comment keyword
style[64 + C.COMMENTDOCKEYWORD] = style[C.COMMENTDOCKEYWORD]
--Comment keyword error
style[64 + C.COMMENTDOCKEYWORDERROR] = style[C.COMMENTDOCKEYWORDERROR]

--Global class
style[64 + C.GLOBALCLASS] = { fore = 0xDD9900 }
--Raw strings for C++0x
style[64 + C.STRINGRAW] = createChild(style[C.STRINGRAW], {
    fore = 0xB090B0,
})

--Preprocessor stream comment
style[64 + C.PREPROCESSORCOMMENT] = createChild(style[C.PREPROCESSORCOMMENT], {
    fore = 0xA0C090,
})
--Preprocessor stream doc comment
style[64 + C.PREPROCESSORCOMMENTDOC] = createChild(style[C.PREPROCESSORCOMMENTDOC], {
    fore = 0xC0C0C0,
})
--User defined literals
style[64 + C.USERLITERAL] = {
    fore = 0xD7A090,
}
style[64 + C.TASKMARKER] = {
    fore = 0xC3A1CF,
}
style[64 + C.ESCAPESEQUENCE] = colors.string


local properties = {}

return function() return keywords, style, properties end
