--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-9
-- Time: 13:25
-- To change this template use File | Settings | File Templates.
--

local CSS = luajava.bindClass("jscintilla.lexers.css")
local keywords = {}

keywords[1] = [[
color background-color background-image background-repeat background-attachment background-position background
font-family font-style font-variant font-weight font-size font
word-spacing letter-spacing text-decoration vertical-align text-transform text-align text-indent line-height
margin-top margin-right margin-bottom margin-left margin
padding-top padding-right padding-bottom padding-left padding
border-top-width border-right-width border-bottom-width border-left-width border-width
border-top border-right border-bottom border-left border
border-color border-style width height float clear
display white-space list-style-type list-style-image list-style-position list-style
]]
keywords[2] = [[
link active visited
first-child focus hover lang left right first

empty enabled disabled checked not root target
only-child last-child nth-child nth-last-child
first-of-type last-of-type nth-of-type nth-last-of-type only-of-type
valid invalid required optional

first-letter first-line before after
]]

keywords[3] = [[
border-top-color border-right-color border-bottom-color border-left-color border-color \
border-top-style border-right-style border-bottom-style border-left-style border-style \
top right bottom left position z-index direction unicode-bidi \
min-width max-width min-height max-height overflow clip visibility content quotes \
counter-reset counter-increment marker-offset \
size marks page-break-before page-break-after page-break-inside page orphans widows \
font-stretch font-size-adjust unicode-range units-per-em src \
panose-1 stemv stemh slope cap-height x-height ascent descent widths bbox definition-src \
baseline centerline mathline topline text-shadow \
caption-side table-layout border-collapse border-spacing empty-cells speak-header \
cursor outline outline-width outline-style outline-color \
volume speak pause-before pause-after pause cue-before cue-after cue \
play-during azimuth elevation speech-rate voice-family pitch pitch-range stress richness \
speak-punctuation speak-numeral
]]

keywords[4] = [[
background-size \
border-radius border-top-right-radius border-bottom-right-radius border-bottom-left-radius border-top-left-radius \
box-shadow \
columns column-width column-count column-rule column-gap column-rule-color column-rule-style column-rule-width \
resize opacity word-wrap
]]

keywords[5] = [[
first-letter first-line before after
selection
]]
keywords[6] = [[
^-moz- ^-webkit- ^-o- ^-ms- filter
]]
keywords[7] = [[
indeterminate default
^-moz- ^-webkit- ^-o- ^-ms-
]]
keywords[8] = [[
^-moz- ^-webkit- ^-o- ^-ms-
]]



local style = {}


--style[CSS.DEFAULT ] =
--Selector(HTML tag)
style[CSS.TAG] = createChild(colors.keyword, {
    bold = true
})
--Class selector ([HtmlTag].classSelector)
--style[CSS.CLASS] =
--Pseudo class (HtmlTag:pseudoClass) see "keywords2" above
style[CSS.PSEUDOCLASS] = {
    fore = 0x800000,
}
--Unknown Pseudo class
style[CSS.UNKNOWN_PSEUDOCLASS] = colors.error
style[CSS.OPERATOR] = colors.operator

--CSS1 Property , see keywords
style[CSS.IDENTIFIER] = colors.keyword
--Unknown Property
style[CSS.UNKNOWN_IDENTIFIER] = {
    fore = 0xFF0000,
}
style[CSS.VALUE] = colors.string
style[CSS.COMMENT] = createStyle(fonts.comment, colors.codeCommentLine, {})
--ID selector (#IdSel)
style[CSS.ID] = createChild(colors.keyword, {
    italics = true
})
--"!important"
style[CSS.IMPORTANT] = {
    fore = 0xFF8000,
    bold = true
}
--At - rule( @) except @ media
style[CSS.DIRECTIVE] = colors.preproc
--Double quoted strings
style[CSS.DOUBLESTRING] = colors.string
--Single quoted strings
style[CSS.SINGLESTRING] = colors.string
--CSS2 Property , see keywords3
style[CSS.IDENTIFIER2] = {
    fore = 0x0040E0,
}
--Attribute selection ([att = 'val'])
style[CSS.ATTRIBUTE] = {
    fore = 0x800000,
}
--CSS3 Property , see keywords4
style[CSS.IDENTIFIER3] = {
    fore = 0x00A0E0,
}
--Pseudo elements , see keywords5
style[CSS.PSEUDOELEMENT] = {
    fore = 0xC80000,
}
--Other CSS Property, see keywords6
style[CSS.EXTENDED_IDENTIFIER] = {
    fore = 0x7F7F00,
}
--Other Pseudoclass , see keywords7
style[CSS.EXTENDED_PSEUDOCLASS] = {
    fore = 0x7F7F00,
}
--Other Pseudoelement , see keywords8
style[CSS.EXTENDED_PSEUDOELEMENT] = {
    fore = 0x7F7F00,
}
--"@media"
style[CSS.MEDIA] = createChild(colors.preproc, {
    bold = true
})
--Variable in SCSS, LESS, or HSS
style[CSS.VARIABLE] = {
    fore = 0xDD9900,
}



local properties = {}

return function() return keywords, style, properties end

