--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-9
-- Time: 20:39
-- To change this template use File | Settings | File Templates.
--


local H = luajava.bindClass("jscintilla.lexers.h")
local keywords = {}


keywords[1] = [[
abbrev abstract accel ackno acronym action address affiliation alt anchor
answer appendix appendixinfo application area areaset areaspec arg article
articleinfo artpagenums attribution audiodata audioobject author authorblurb
authorgroup authorinitials beginpage bibliocoverage bibliodiv biblioentry
bibliography bibliographyinfo biblioid bibliomisc bibliomixed bibliomset
bibliorelation biblioset bibliosource blockinfo blockquote book bookinfo
bridgehead callout calloutlist caption caution chapter chapterinfo citation
citebiblioid citerefentry citetitle city classname classsynopsis classsynopsisinfo
cmdsynopsis co collab collabname colophon colspec command computeroutput
confdates confgroup confnum confsponsor conftitle constant constraint
constraintdef constructorsynopsis contractnum contractsponsor contrib
copyright coref corpauthor corpname country database date dedication
destructorsynopsis edition editor email emphasis entry entrytbl envar
epigraph equation errorcode errorname errortext errortype example
exceptionname fax fieldsynopsis figure filename firstname firstterm
footnote footnoteref foreignphrase formalpara funcdef funcparams
funcprototype funcsynopsis funcsynopsisinfo function glossary glossaryinfo
glossdef glossdiv glossentry glosslist glosssee glossseealso glossterm
graphic graphicco group guibutton guiicon guilabel guimenu guimenuitem
guisubmenu hardware highlights holder honorific htm imagedata imageobject
imageobjectco important index indexdiv indexentry indexinfo indexterm
informalequation informalexample informalfigure informaltable initializer
inlineequation inlinegraphic inlinemediaobject interface interfacename
invpartnumber isbn issn issuenum itemizedlist itermset jobtitle keycap
keycode keycombo keysym keyword keywordset label legalnotice lhs lineage
lineannotation link listitem iteral literallayout lot lotentry manvolnum
markup medialabel mediaobject mediaobjectco member menuchoice methodname
methodparam methodsynopsis mm modespec modifier ousebutton msg msgaud
msgentry msgexplan msginfo msglevel msgmain msgorig msgrel msgset msgsub
msgtext nonterminal note objectinfo olink ooclass ooexception oointerface
option optional orderedlist orgdiv orgname otheraddr othercredit othername
pagenums para paramdef parameter part partinfo partintro personblurb
personname phone phrase pob postcode preface prefaceinfo primary primaryie
printhistory procedure production productionrecap productionset productname
productnumber programlisting programlistingco prompt property pubdate publisher
publishername pubsnumber qandadiv qandaentry qandaset question quote refclass
refdescriptor refentry refentryinfo refentrytitle reference referenceinfo
refmeta refmiscinfo refname refnamediv refpurpose refsect1 refsect1info refsect2
refsect2info refsect3 refsect3info refsection refsectioninfo refsynopsisdiv
refsynopsisdivinfo releaseinfo remark replaceable returnvalue revdescription
revhistory revision revnumber revremark rhs row sbr screen screenco screeninfo
screenshot secondary secondaryie sect1 sect1info sect2 sect2info sect3 sect3info
sect4 sect4info sect5 sect5info section sectioninfo see seealso seealsoie
seeie seg seglistitem segmentedlist segtitle seriesvolnums set setindex
setindexinfo setinfo sgmltag shortaffil shortcut sidebar sidebarinfo simpara
simplelist simplemsgentry simplesect spanspec state step street structfield
structname subject subjectset subjectterm subscript substeps subtitle
superscript surname sv symbol synopfragment synopfragmentref synopsis
systemitem table tbody term tertiary tertiaryie textdata textobject tfoot
tgroup thead tip title titleabbrev toc tocback tocchap tocentry tocfront
toclevel1 toclevel2 toclevel3 toclevel4 toclevel5 tocpart token trademark
type ulink userinput varargs variablelist varlistentry varname videodata
videoobject void volumenum warning wordasword xref year

arch condition conformance id lang os remap role revision revisionflag security
userlevel vendor xreflabel
status label endterm linkend space width
]]


local style = {}

--style[H.DEFAULT] =
--style[H.TAG] =
style[H.TAGUNKNOWN] = {
    fore = 0xFF0000,
}
style[H.ATTRIBUTE] = {
    fore = 0x008080,
}
style[H.ATTRIBUTEUNKNOWN] = {
    fore = 0xFF0000,
}
style[H.NUMBER] = colors.number
style[H.DOUBLESTRING] = colors.string
style[H.SINGLESTRING] = colors.char
--Other inside tag, including space and '='
style[H.OTHER] = {
    fore = 0x800080,
}
style[H.COMMENT] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[H.ENTITY] = {
    fore = 0x800080,
}
--XML style tag ends '/>'
style[H.TAGEND] = {
    fore = 0x000080,
}
--XML identifier start '<?'
style[H.XMLSTART] = {
    fore = 0x0000FF,
}
--XML identifier end '?>'
style[H.XMLEND] = {
    fore = 0x0000FF,
}
--Internal state which should never be visible
style[H.SCRIPT] = {
    back = 0xFF0000,
}
--ASP < %... % >
style[H.ASP] = {
    back = 0xFFFF00,
}
--ASP < %... % >
style[H.ASPAT] = {
    back = 0xFFDF00,
}
style[H.CDATA] = {
    back = 0xFFDF00,
}
--php
style[H.QUESTION] = {
    fore = 0x0000FF,
    back = 0xFFEFBF,
}
--Unquoted values
style[H.VALUE] = {
    fore = 0xFF00FF,
    back = 0xFFEFFF,
}
--JSP Comment < % -- ... --%>
style[H.XCCOMMENT] = {
    fore = 0x000000,
    back = 0xFFFFD0,
}
--SGML tags < !... >
style[H.SGML_DEFAULT] = {
    fore = 0x000080,
}
--SGML command
style[H.SGML_COMMAND] = {
    fore = 0x000080,
    bold = true
}
style[H.SGML_1ST_PARAM] = {
    fore = 0x006600,
}
style[H.SGML_DOUBLESTRING] = {
    fore = 0x800000,
}
style[H.SGML_SIMPLESTRING] = {
    fore = 0x993300,
}
style[H.SGML_ERROR] = {
    fore = 0x800000,
    back = 0xFF6666,
}
--SGML special (#XXXX type)
style[H.SGML_SPECIAL] = {
    fore = 0x3366FF,
}
style[H.SGML_ENTITY] = {
    fore = 0x333333,
}
style[H.SGML_COMMENT] = {
    fore = 0x808000,
}
style[H.SGML_1ST_PARAM_COMMENT] = {
    fore = 0x808000,
    back = 0xFF0000,
}
style[H.SGML_BLOCK_DEFAULT] = {
    fore = 0x000066,
    back = 0xCCCCE0,
}



local properties = {}

return function() return keywords, style, properties end

