--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-5
-- Time: 13:43
-- To change this template use File | Settings | File Templates.
--
local C = luajava.bindClass("jscintilla.lexers.c")
local keywords = {}

keywords[1] = [[
abstract boolean break byte case catch char class
const continue debugger default delete do double else enum export extends
final finally float for function goto if implements import in instanceof
int interface long native new package private protected public
return short static super switch synchronized this throw throws
transient try typeof var void volatile while with
]]

local style = {}

--style[C.DEFAULT] =
--Comment: /* */.
style[C.COMMENT] = createStyle(fonts.codeCommentBox, colors.codeCommentBox, {})
--Line Comment: //.
style[C.COMMENTLINE] = createStyle(fonts.codeCommentLine, colors.codeCommentLine, {})
--Doc comment: block comments beginning with /** or /*
style[C.COMMENTDOC] = createStyle(fonts.codeCommentLine, colors.codeCommentDocText, {})
--Number
style[C.NUMBER] = colors.number
--Keyword
style[C.WORD] = createChild(colors.keyword, { bold = true })
--Double quoted string
style[C.STRING] = colors.string
--Single quoted string
style[C.CHARACTER] = colors.char
--Preprocessor
style[C.PREPROCESSOR] = colors.preproc
--Operators
style[C.OPERATOR] = colors.operator
--style[C.IDENTIFIER] =

--End of line where string is not closed
style[C.STRINGEOL] = {
    fore = 0x000000,
    back = 0xE0C0E0,
    eolfilled = true
}
style[C.REGEX] = {
    fore = 0x3F7F3F,
    back = 0xE0F0FF,
    eolfilled = true
}

--Doc Comment Line: line comments beginning with /// or //!.
style[C.COMMENTLINEDOC] = createStyle(fonts.codeCommentLine, colors.codeCommentDocText, {})

--keywords2 is for highlighting user defined keywords or function calls or similar
--Keywords2
style[C.WORD2] = { fore = 0xC0C0C0 }

--Comment keyword
style[C.COMMENTDOCKEYWORD] = { fore = 0xC0C0C0 }
--Comment keyword error
style[C.COMMENTDOCKEYWORDERROR] = { fore = 0xC0C0C0 }

--Global class
style[C.GLOBALCLASS] = { fore = 0xDD9900 }
--Raw strings for C++0x
--style[C.STRINGRAW] = {
--    back = 0xFFF3FF,
--    eolfilled = true
--}
--Triple-quoted strings for Vala
--style[C.TRIPLEVERBATIM] =
--Hash-quoted strings for Pike
--style[C.HASHQUOTEDSTRING] =

--Preprocessor stream comment
style[C.PREPROCESSORCOMMENT] = { fore = 0x659900 }
--Preprocessor stream doc comment
style[C.PREPROCESSORCOMMENTDOC] = colors.codeCommentDocText
--User defined literals
style[C.USERLITERAL] = { fore = 0xC06000 }
style[C.TASKMARKER] = { fore = 0xBE07FF }
style[C.ESCAPESEQUENCE] = colors.string

local properties = {}

return function() return keywords, style, properties end
