--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-8
-- Time: 17:23
-- To change this template use File | Settings | File Templates.
--

local PY = luajava.bindClass("jscintilla.lexers.p")
local keywords = {}
keywords[1] = [[
and as assert break class continue def del elif
else except exec finally for from global if import in is lambda not
or pass print raise return try while with yield

cdef cimport cpdef
]]

local style = {}

--style[PY.DEFAULT ] =
--Comment
style[PY.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[PY.NUMBER] = colors.number
--String
style[PY.STRING] = colors.string
--Single quoted string
style[PY.CHARACTER] = colors.string
--Keyword
style[PY.WORD] = createChild(colors.keyword, { bold = true })
--Triple quotes
style[PY.TRIPLE] = colors.string
--Triple double quotes
style[PY.TRIPLEDOUBLE] = colors.string
--Class name definition
style[PY.CLASSNAME] = { bold = true }
--Function or method name definition
style[PY.DEFNAME] = { bold = true }
--Operators
style[PY.OPERATOR] = colors.operator
--Identifiers
--style[PY.IDENTIFIER] =
--Comment-blocks
style[PY.COMMENTBLOCK] = createStyle(fonts.comment, colors.codeCommentBox, {})
--End of line where string is not closed
style[PY.STRINGEOL] = createChild(colors.string, {
    eolfilled = true
})
--Highlighted identifiers
--style[PY.WORD2] =
--Decorators
style[PY.DECORATOR] = {
    fore = 0x805000
}
--F-String
style[PY.FSTRING] = colors.string
--Single quoted f-string
style[PY.FCHARACTER] = colors.string
--Triple quoted f-string
style[PY.FTRIPLE] = colors.string
--Triple double quoted f-string
style[PY.FTRIPLEDOUBLE] = colors.string


local properties = {}

return function() return keywords, style, properties end
