--
-- Created by IntelliJ IDEA.
-- User: mao
-- Date: 20-6-8
-- Time: 13:02
-- To change this template use File | Settings | File Templates.
--


local RS = luajava.bindClass("jscintilla.lexers.rust")
local keywords = {}

keywords[1] = [[
alignof as be box break const continue crate do else enum extern false fn
for if impl in let loop match mod mut offsetof once priv proc pub pure ref
return self sizeof static struct super trait true type typeof unsafe unsized use virtual while yield
]]
keywords[2] = [[
bool char f32 f64 i16 i32 i64 i8 int str u16 u32 u64 u8 uint
]]
keywords[3] = "Self"


local style = {}

--style[RS.DEFAULT] =
style[RS.COMMENTBLOCK] = createStyle(fonts.comment, colors.codeCommentBox, {})
style[RS.COMMENTLINE] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[RS.COMMENTBLOCKDOC] = createStyle(fonts.comment, colors.codeCommentBox, {})
style[RS.COMMENTLINEDOC] = createStyle(fonts.comment, colors.codeCommentLine, {})
style[RS.NUMBER] = colors.number
style[RS.WORD] = colors.keyword
style[RS.WORD2] = createChild(colors.keyword, {
    bold = true
})
style[RS.WORD3] = createChild(colors.keyword, {
    bold = true
})
style[RS.WORD4] = createChild(colors.keyword, {
    bold = true
})
style[RS.WORD5] = createChild(colors.keyword, {
    bold = true
})
style[RS.WORD6] = createChild(colors.keyword, {
    bold = true
})
style[RS.WORD7] = createChild(colors.keyword, {
    bold = true
})
--Regular string
style[RS.STRING] = colors.string
--Raw string
style[RS.STRINGR] = {
    fore = 0xB090B0,
}
style[RS.CHARACTER] = colors.char
style[RS.OPERATOR] = colors.operator
--style[RS.IDENTIFIER] =
style[RS.LIFETIME] = {
    fore = 0x007F7F,
}
style[RS.MACRO] = colors.preproc
--Lexical error
style[RS.LEXERROR] = {
    fore = 0x000000,
    back = 0xE0C0E0,
}
style[RS.BYTESTRING] = colors.string
--Raw byte string
style[RS.BYTESTRINGR] = {
    fore = 0xB090B0,
}
--Byte character
style[RS.BYTECHARACTER] = colors.char

local properties = {}

return function() return keywords, style, properties end

